# import logging
# from typing import Tuple, List, Union
#
# # from gcma.io.baseio import BaseIO, TValue, Bases
#
#
# import treefiles as tf
# from treefiles.baseio.param import r
#
# _Bounds = Tuple[tf.TValue, tf.TValue]
#
#
# class Param(tf.BaseIO):
#     def __init__(
#         self, *args, initial_value: tf.TValue = None, bounds: _Bounds = None, **kwargs
#     ):
#         super().__init__(*args, **kwargs)
#         self.initial_value = initial_value
#         self.bounds = bounds
#
#         self.registered.add("initial_value")
#         self.registered.add("bounds")
#
#     @property
#     def table(self):
#         return Params(self).table
#
#
# class Params(tf.Bases[Param]):
#     # inner_class = Param
#
#     def build_table(self) -> Tuple[tf.Bases.THeader, tf.Bases.TData]:
#         header = ["Name", "Baseline", "Value", "Bounds", "Unit"]
#         data = [
#             [x.name, x.initial_value, r(x.value), x.bounds, x.unit]
#             for x in self.values()
#         ]
#         return header, data
#
#     @property
#     def bounds(self):
#         return [x.bounds for x in self.values()]
#
#
# TParams = Union[List[Param], Params]
#
# log = logging.getLogger(__name__)
